;  ..  2005.
; a_biv @ list . ru   
	list      p=16f628            ; list directive to define processor
	#include <p16f628.inc>        ; processor specific variable definitions
	__CONFIG _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _LVP_OFF
;------------------------------------------
#define		Led_b0	PORTB,0
#define		Led_b1	PORTB,1
#define		Led_b2	PORTB,2
#define		Led_b3	PORTB,3
#define		Led_b4	PORTB,4
#define		Led_b5	PORTB,5
#define		Led_b6	PORTB,6
#define		Led_b7	PORTB,7
#define		_RP0	STATUS,RP0
#define		_GIE	INTCON,GIE
;------------------------------------------
		cblock	   0x70
	Led0,Led1,Led2,Led3,Led4,Led5,Led6,Led7	;  `
	PWM_Cycle			;  `a
	TabAdr0,TabAdr1		;   
	TabAdrT0,TabAdrT1	;    ()
		endc
;**********************************************************************
		ORG     0x0000
		goto	Init
;---------------------------------------------------------------
		ORG     0x0004   ; ----   TMR0 ---- 1 
		bcf		PIR1,TMR1IF	;  
		clrwdt
		bsf		_GIE	;   
		call	Tab_Pwm	;   `
Loop_Int	;  
		movfw	Led0		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b0		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b0		;  
		;  
		movfw	Led1		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b1		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b1		;  
		;  
		movfw	Led2		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b2		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b2		;  
		;  
		movfw	Led3		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b3		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b3		;  
		;  
		movfw	Led4		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b4		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b4		;  
		;  
		movfw	Led5		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b5		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b5		;  
		;  
		movfw	Led6		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b6		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b6		;  
		;  
		movfw	Led7		; "A"
		addwf	PWM_Cycle,w	; "B"     "A"+"B"=W
		bcf		Led_b7		;  
		btfsc	STATUS,C	; skip if Carry
		bsf		Led_b7		;  
		incf	PWM_Cycle,f
		goto	Loop_Int	;    
;**********************************************************************
PWM_Vol	; 16   ->  `
		clrf	PCLATH
		addwf	PCL,F	; W + PC -> PC
		retlw	0x00	;0
		retlw	0x01	;1
		retlw	0x02	;2
		retlw	0x04	;3
		retlw	0x06	;4
		retlw	0x0A	;5
		retlw	0x12	;6
		retlw	0x19	;7
		retlw	0x20	;8
		retlw	0x30	;9
		retlw	0x47	;a
		retlw	0x60	;b
		retlw	0x80	;c
		retlw	0xA0	;d
		retlw	0xC0	;e
		retlw	0xF0	;f
;**********************************************************************
Tab_Pwm
		call	Out_Tabl	;   - Led0,   - Led1
		movwf	Led1
		swapf	Led1,w
		andlw	0x0F	;     Led0
		call	PWM_Vol
		movwf	Led0
		movlw	0x0F
		andwf	Led1,w	;   Led1
		call	PWM_Vol
		movwf	Led1		; ( 41  )
		call	Out_Tabl	;   - Led2,   - Led3
		movwf	Led3
		swapf	Led3,w
		andlw	0x0F	;     Led2
		call	PWM_Vol
		movwf	Led2
		movlw	0x0F
		andwf	Led3,w	;   Led1
		call	PWM_Vol
		movwf	Led3		; ( 41  )
		call	Out_Tabl	;   - Led4,   - Led5
		movwf	Led5
		swapf	Led5,w
		andlw	0x0F	;     Led4
		call	PWM_Vol
		movwf	Led4
		movlw	0x0F
		andwf	Led5,w	;   Led1
		call	PWM_Vol
		movwf	Led5		; ( 41  )
		call	Out_Tabl	;   - Led6,   - Led7
		movwf	Led7
		swapf	Led7,w
		andlw	0x0F	;     Led6
		call	PWM_Vol
		movwf	Led6
		movlw	0x0F
		andwf	Led7,w	;   Led1
		call	PWM_Vol
		movwf	Led7		; ( 41  )
		return
;**********************************************************************
Init   ; -------------------  
		clrf	STATUS	  ;     
		clrf	PORTA 
		clrf	PORTB
		movlw	B'00000111'
		movwf	CMCON		;  
		movlw	B'01000000'
		movwf	INTCON
		bsf		_RP0
		movlw	B'00000001'	;  TMR1
		movwf	PIE1
		movlw  	B'11111111'
       	movwf	TRISA
		movlw  	B'00000000'
       	movwf	TRISB
		movlw  	B'11001111'	;
       	movwf	OPTION_REG
		bcf		_RP0		
		movlw  	B'00000001'
       	movwf	T1CON		; TMR1 - Fosc/4 /1 /65536
		clrf	PIR1
      	movlw 	0x20  ;-----------       
      	movwf 	FSR
ClearReg
      	clrf  	INDF
      	incf  	FSR,f
      	btfss 	FSR,7
      	goto  	ClearReg
		bsf		_GIE
		goto	$-1		;  
;**********************************************************************
Out_Tabl
		incf	TabAdr0,f
		btfsc	STATUS,Z
		incf	TabAdr1,f ; ------   
		movfw	TabAdr1
		movwf	TabAdrT1  ; -----   
		movfw	TabAdr0
		movwf	TabAdrT0  ; -----   
		movlw	High dtmf_file	
		addwf	TabAdrT1,f
		movlw	Low dtmf_file	
		addwf	TabAdrT0,f
		btfsc	STATUS,C
		incf	TabAdrT1,f	; ----   +   
		movfw	TabAdrT1
		movwf	PCLATH
		movfw	TabAdrT0
		movwf	PCL
dtmf_file
		nop		; -  incf`
	include <Pwm.h>	;     DTMF		
		goto	Init  ;   (  )
		ORG     0x07FF
		goto	Init  ;   (  )
;**********************************************************************
		END                       ; end of program
